#include<stdio.h>
#include<stdlib.h>
#include<unistd.h>

// Imprime evolucao da string inicial de acordo com a regra de celular
// automatum <regra>. A string tem <N> elementos binarios.

int main(int argv, char **argc){

  int regra,N,i,t,tmax,**phi,table[2][2][2],b1,b2,b3,r;

  if(argv!=4){
    printf("Uso: %s <regra> <N> <# de iteracoes>\n",argc[0]);
    exit(1);
  }
  
  regra=atoi(argc[1]);
  N=atoi(argc[2]);
  tmax=atoi(argc[3]);

  // Descobre tabela-verdade (regras) do automatum celular
  printf("Regras:\n");
  for(t=0;t<8;t++){
    b1=(t&1);
    b2=(t>>1)&1;
    b3=(t>>2)&1;
    r=(regra>>t)&1;
    table[b3][b2][b1]=r;
    printf("%d%d%d -> %d\n",b3,b2,b1,r);
  }

  // Reserva espaco na memoria para a matriz phi
  phi=(int **)malloc(N*sizeof(int *));
  for(t=0;t<N;t++)
    phi[t]=(int *)malloc(2*sizeof(int *));

  for(i=0;i<N;i++)
    phi[i][0]=0;
  phi[N/2][0]=1;
  
  for(i=0;i<N;i++)
        if(phi[i][0]==1)
      printf("#");
	else
	  printf(" ");

  printf("\n");

  for(t=1;t<tmax;t++){
    for(i=0;i<N;i++){
      b1=phi[(i+1)%N][(t-1)%2];
      b2=phi[i][(t-1)%2];
      b3=phi[(i-1+N)%N][(t-1)%2];
      phi[i][t%2]=table[b3][b2][b1];
      if(phi[i][t%2]==1)
	printf("#");
      else
	printf(" ");
    }
    printf("\n");
    usleep(50000);
}


  return(0);
  
}
