#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<math.h>

// Programa que retorna o diagrama de bifurcacao do mapa logistico
// Para cada valor de lambda retorna os max_iter-transient pontos
// visitados no atrator

void main(int argv,char **argc){

#define NBINS  1000 // Precisao de 1/NBINS no diagrama. 
  unsigned long t,transient,max_iter,H[NBINS];
  double x,xa,x0,mu,mu_i,mu_f,dm;
  char arq[100];
  FILE *out_evol,*out_bifurcation;

  if(argv != 7){
    printf("Uso: <%s> <mu_i> <mu_f> <dm> <x0> <max_iter> <transient>, onde 0.0<=x0<=1.0 \n",argc[0]);
    exit(1);
  }
  mu_i=atof(argc[1]);
  mu_f=atof(argc[2]);
  dm=atof(argc[3]);
  x0=atof(argc[4]);
  max_iter=(unsigned long)atol(argc[5]);
  transient=(unsigned long)atol(argc[6]);
  if((x0>=1.0)||(x0<0.0) || (max_iter < 0)){
    printf("Uso: <%s> <mu_i> <mu_f> <dm> <x0> <max_iter>, onde 0.0<=x0<=1.0 \n",argc[0]);
    exit(1);
  }

  sprintf(arq,"bifurcation_li%1.4lf_lf%1.4lf_np%lu.data",mu_i,mu_f,max_iter-transient);
  out_bifurcation=fopen(arq,"w");

  for(mu=mu_i;mu<=mu_f;mu+=dm){
    memset(H,0,sizeof(H));
    xa=x0;
    for(t=0;t<max_iter;t++){
      x=mu*xa*(1-xa);
      if(t>transient){
	if(H[(unsigned long)(x*NBINS)] == 0){ // precisao de 3 casas decimais
	  fprintf(out_bifurcation,"%lf %lf\n",mu,x);
	  H[(unsigned long)(x*NBINS)]=1;
	}
      }
      xa=x;
    }
  }
  fclose(out_bifurcation);
}
